$(document).ready(function() {
  var socket = io.connect();
  var tmp = "";
  $("#actionStore").hide();
  $("#operation").hide();
  $("#matching").hide();
  $("#description").hide();
// handle different button
  var buttonClicked = (function(){
  	return {
  		status: function(){
  			socket.emit('statusReq');
  		},
  		calibration: function(){
  			socket.emit('calibrationReq');
  		},
  		log: function(){
  			socket.emit('logReq', { room: "logging"});
  		},
  		custom: function(){
  			socket.emit('matchingReq');
  		},
        storeAction: function(name){
            socket.emit('storeAction', { action: name});
        },
        operation: function(name){
            socket.emit('operation', {action:name});
        },
        matching: function(opt){
            socket.emit('matching', opt, matchingArray);
        },
        descript: function(){
            socket.emit('descriptionReq');
        }
  	};
  })();

  var getTimestamp = function(){
  	return (new Date()).toUTCString();
  };
 //add event listener   
  document.addEventListener("dragstart", function(ev) {
      ev.dataTransfer.setData("text", ev.target.id);
  });
  document.addEventListener("dragover", function(ev) {
      ev.preventDefault();
  });
  document.addEventListener("drop", function(ev) {
      ev.preventDefault();
      var data = ev.dataTransfer.getData("text");
      ev.target.appendChild(document.getElementById(data));
      var targetId = ev.target.id.substr(1);
      matchingArray[data] = targetId;
      console.log(matchingArray);
  });
// drag and drop
  var allowDrop = function allowDrop(ev) {
    ev.preventDefault();
  };

  var drag = function drag(ev) {
    ev.dataTransfer.setData("text", ev.target.id);
  };

  var drop = function drop(ev) {
    ev.preventDefault();
    var data = ev.dataTransfer.getData("text");
    ev.target.appendChild(document.getElementById(data));
    var targetId = ev.target.id.substr(1);
    matchingArray[data] = targetId;
    console.log(matchingArray);
  };
// store new gesture control setting
  var matchingArray = {
        
    "double_tap":"null",
    "fingers_spread":"null",
    "fist":"null",
    "fistup":"null",
    "fistdown":"null",
    "fistright":"null",
    "fistleft":"null",
    "fistclockwise":"null",
    "fistanticlockwise":"null",
    "fistpunch":"null",
    "wave_in":"null",
    "wave_inup":"null",
    "wave_indown":"null",
    "wave_inright":"null",
    "wave_inleft":"null",
    "wave_inclockwise":"null",
    "wave_inanticlockwise":"null",
    "wave_inpunch":"null",
    "wave_out":"null",
    "wave_outup":"null",
    "wave_outdown":"null",
    "wave_outright":"null",
    "wave_outleft":"null",
    "wave_outclockwise":"null",
    "wave_outanticlockwise":"null",
    "wave_outpunch":"null"
  };
  // store the path of sound file
  var act = {
        
    "forward":"./sound/forward.wav",
    "forwardleft":"./sound/forwardleft.wav",
    "forwardright":"./sound/forwardright.wav",
    "backward":"./sound/backward.wav",
    "backwardleft":"./sound/backwardleft.wav",
    "backwardright":"./sound/backwardright.wav",
    "bowup":"./sound/bowup.wav",
    "bowdown":"./sound/bowdown.wav",
    "punchleft":"./sound/punchleft.wav",
    "punchright":"./sound/punchright.wav",
    "open":"./sound/open.wav",
    "close":"./sound/close.wav",
    "rotateleft":"./sound/rotateleft.wav",
    "rotateright":"./sound/rotateright.wav",
    "rotatestop":"./sound/rotatestop.wav",
    "turnleft":"./sound/turnleft.wav",
    "turnright":"./sound/turnright.wav",
    "reset":"./sound/reset.wav",
    "play": "playarray"
  };
// emit leave log tab
  $("#buttons").on("click", "a", function(e){
  	e.preventDefault();
  	var buttonId = e.target.id;
  	if(buttonId !== "log"){
  		socket.emit("leaveLogging");
  	}
  	buttonClicked[buttonId]();
  	$(".well").empty();
  });
  // emit clean request
  $("#actions").on("click", "a", function(e) {
      e.preventDefault();
      var buttonId = e.target.id;
      buttonClicked.storeAction(buttonId);
      if(e.target.id !== "clean"){
        $("#records").append($(this).html() + "<br>");
      }else {
        $("#records").empty();
      }
  });
    // emit start and stop request
  $('#robotControl').on("click", "a", function(e){
      e.preventDefault();
      var buttonId = e.target.id;
      buttonClicked.operation(buttonId);
      console.log(e.target.id);
  });
  //emit new gesture control setting
  $('#setup').on("click", "a", function(e){
      e.preventDefault();
      var buttonId = e.target.id;
      buttonClicked.matching(buttonId);
      console.log(e.target.id);
  });
// display information in log tab
  socket.on("status", function(temp, data){
  	$(".well").append(temp.info + "<br>");
  	var txt = "";
  	$.each(data, function(i, key){
  		if(typeof key === "object"){
  			txt += i + ": {<br>";
  			$.each(key, function(i2, key2){
  				if(typeof key2 === "object"){
  					txt += " " + i2 + ": {<br>";
  					$.each(key2, function(i3, key3){
  						txt += " - " + i3 + ": " + key3 + "<br>";
  					});
  					txt += "  }<br>";
  				}else{
  					txt += "- " + i2 + ": " + key2 + "<br>";
  				}
  			});
  			txt += "}<br>";
  		}else{
  			txt += i + ": " + key + "<br>";
  		}
  	})
  	$(".well").append(txt);
    $("#info").show();
    $("#actionStore").hide();
    $("#operation").hide();
    $("#matching").hide();
    $("#description").hide();
  });
// display recording tab
  socket.on("calibration", function(data, array){
    $("#info").hide();
  	$("#actionStore").show();
    $("#operation").hide();
    $("#matching").hide();
    $("#description").hide();
    for(var i = 0; i < array.length; i++) {
        $("#records").append(array[i] + "<br>");
    }
  });
  
//display log tab
  socket.on("log", function(data){
  	$(".well").append(data.info + "<br>");
  	$(".well").append(tmp);
    $("#info").show();
    $("#actionStore").hide();  
    $("#operation").show();
    $("#matching").hide();
    $("#description").hide();
  });
  
  socket.on("showmenu", function(data){
    document.getElementById("menu").innerHTML = data;
  });
//display customization tab
  socket.on("matching", function(data){
  	$(".well").append(data.info + "<br>");
    $("#matching").show();
    $("#info").hide();
    $("#actionStore").hide();  
    $("#operation").hide();
    $("#description").hide();
  });
// display input gesture in log tab
  socket.on("logSession", function(data){
  	tmp += getTimestamp() + " : " + data + "<br>";
  });

  socket.on("instantLog", function(data){
  	$(".well").append(getTimestamp() + " : " + data + "<br>").scrollTop(1000);
  });
  // display input gesture in recording tab
  socket.on("instantCalibrate", function(data) {
    $("#records").append(data + "<br>");
  });
  //display description tap
  socket.on("description", function(){
    $("#matching").hide();
    $("#info").hide();
    $("#actionStore").hide();  
    $("#operation").hide();
    $("#description").show();
  });

});
